﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace com.WizardWu
{
    [System.ComponentModel.DataObject]
    public class SqlServer2005_BLL
    {
        SqlServer2005_DAL da = new SqlServer2005_DAL();     // 全域變數

        public SqlServer2005_BLL()
        {}

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]  // true 表示為 ObjectDataSource 要 SELECT 時的預設值
        public DataSet selectDataSetBindGridView_BLL(string tbOrderID, string tbCustomerID, int startRowIndex, int maxinumRows, string sortExpression)
        {
            // 最後三個參數：startRowIndex, maxinumRows, sortExpression，ObjectDataSource 控制項會自動傳入，開發人員不用手動撰碼傳值

            DataSet ds = null;

            try
            {
                if (tbOrderID == null)      // 使用者輸入的第一個查詢關鍵字 (OrderID)
                {
                    tbOrderID = "";
                }
                if (tbCustomerID == null)   // 使用者輸入的第二個查詢關鍵字 (CustomerID)
                {
                    tbCustomerID = "";
                }

                ds = da.selectDataSetBindGridView_DAL(tbOrderID.Trim(), tbCustomerID.Trim(), startRowIndex, maxinumRows, sortExpression);
            }
            catch (Exception ex)    // BLL 層接到 DAL 層傳來的錯誤訊息
            {
                throw new Exception(ex.Message);    // 資料庫存取發生錯誤，或網路中斷、資料庫關機
            }

            return ds;
        }


        // 從 Stored Procedure 回傳的一個整數，為符合查詢條件的資料總筆數，用來在 GridView 下方的「頁碼列」顯示頁碼之用(Ex: 1 2 3 4 ... 55)
        public int getRecordCountBLL(string tbOrderID, string tbCustomerID)
        {
            return da.getRecordCountDAL();
        }


    } // end of class
} // end of namespace
