﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace com.WizardWu
{
    public class SqlServer2005_DAL
    {
        SqlServer2005_DAL2 dba = new SqlServer2005_DAL2();    // 全域變數

        public SqlServer2005_DAL()
        {}

        // GridView 的撈取作業。若使用者有在 TextBox 輸入的關鍵字，就做關鍵字「模糊查詢」
        #region ****** 透過 SqlServer2005_DAL2 的 SelectDataSet 函數，去 SELECT 資料庫並回傳一個 DataSet (搭配 Stored Procedure 做「分頁」處理) ******

        public DataSet selectDataSetBindGridView_DAL(string tbOrderID, string tbCustomerID, int startRowIndex, int maxinumRows, string sortExpression)
        {
            DataSet ds = null;

            #region ****** 情況 1 - SELECT 單一個資料表的寫法 ******

            string strTableName = "Orders ";                                // 要撈的資料表 (單一資料表)
            string strColumnName = "OrderID, CustomerID, OrderDate, ShipName, ShipCity";        // 要撈的資料表欄位。亦可寫成 * 全撈 (但建議只撈取 GridView 真正需要的欄位)
            string strDefaultOrderColumn = "OrderID";                       // 預設的排序欄位

            string strSqlWhere = string.Empty;      // SELECT SQL 的 WHERE 條件 (包含使用者輸入的兩個搜尋關鍵字)

            // 若此 GridView 不提供使用者輸入關鍵字查詢功能，則免加以下這段
            if (tbOrderID != "")        // 若使用者在前端畫面中，第一個關鍵字的 TextBox 有輸入，就進入此區塊
            {
                strSqlWhere = strSqlWhere + "OrderID LIKE '%" + tbOrderID + "%' AND ";            // 關鍵字(字串)模糊查詢的寫法
            }
            if (tbCustomerID != "")      // 若使用者在前端畫面中，第二個關鍵字的 TextBox 有輸入，就進入此區塊
            {
                strSqlWhere = strSqlWhere + "CustomerID LIKE '%" + tbCustomerID + "%' AND ";        // 關鍵字(字串)模糊查詢的寫法
            }

            #endregion ****** 情況 1 - SELECT 單一個資料表的寫法 ******


            #region ****** 情況 2 - SELECT 多個資料表，未使用 JOIN...ON 的寫法 ******

            //// 若 SELECT 兩或多個資料表時，有同名欄位，請用 AS 關鍵字，賦予欄位另一個名稱(臨時的代號)，
            //// 否則使用者在 GridView 點選該欄位的 title 排序時，會產生 Error

            //string strTableName = "Orders a, Employees b ";                 // 要撈的資料表 (兩或多個資料表)
            //string strColumnName = "a.OrderID, a.CustomerID, a.EmployeeID, b.EmployeeID AS b_empid, a.OrderDate, b.Title";  // 要撈的資料表欄位。亦可寫成 * 或 a.* 全撈 (但建議只撈取 GridView 真正需要的欄位)
            //string strDefaultOrderColumn = "a.OrderID";                     // 預設的排序欄位

            //string strSqlWhere = string.Empty;      // SELECT SQL 的 WHERE 條件 (包含使用者輸入的兩個搜尋關鍵字)

            //// 把 EmployeeID 欄位當作 JOIN 的 WHERE 條件式
            //strSqlWhere = " a.EmployeeID = b.EmployeeID AND ";

            //// 因 a,b 兩個資料表，都有 EmployeeID 欄位，若把 EmployeeID 欄位當作 JOIN 的 WHERE 條件式時，在 SQL Server 中會發生分不清是哪個欄位的錯誤，
            //// 因此再加入下列這段 if 判斷的處理
            //if (!string.IsNullOrEmpty(sortExpression))
            //{
            //    if ((sortExpression == "EmployeeID") || (sortExpression == "EmployeeID DESC"))
            //        sortExpression = "a." + sortExpression;

            //    if (sortExpression == "b_empid")
            //        sortExpression = "b.EmployeeID";
            //    else if (sortExpression == "b_empid DESC")
            //        sortExpression = "b.EmployeeID DESC";
            //}

            //// 若此 GridView 不提供使用者輸入關鍵字查詢功能，則免加以下這段
            //if (tbOrderID != "")        // 若使用者在前端畫面中，第一個關鍵字的 TextBox 有輸入，就進入此區塊
            //{
            //    strSqlWhere = strSqlWhere + "a.OrderID LIKE '%" + tbOrderID + "%' AND ";          // 關鍵字(字串)模糊查詢的寫法
            //}
            //if (tbCustomerID != "")      // 若使用者在前端畫面中，第二個關鍵字的 TextBox 有輸入，就進入此區塊
            //{
            //    strSqlWhere = strSqlWhere + "a.CustomerID LIKE '%" + tbCustomerID + "%' AND ";      // 關鍵字(字串)模糊查詢的寫法
            //}

            #endregion ****** 情況 2 - SELECT 多個資料表，未使用 JOIN...ON 的寫法 ******


            #region ****** 情況 3 - SELECT 多個資料表，使用 JOIN...ON 的寫法 (包括 LEFT JOIN 或 INNER JOIN) ******

            //// 若 SELECT 兩或多個資料表時，有同名欄位，請用 AS 關鍵字，賦予欄位另一個名稱(臨時的代號)，
            //// 否則使用者在 GridView 點選該欄位的 title 排序時，會產生 Error

            //string strTableName = "Orders a LEFT JOIN Employees b ON a.EmployeeID = b.EmployeeID ";     // 要撈的資料表 (兩或多個資料表 JOIN)
            //string strColumnName = "a.OrderID, a.CustomerID, a.EmployeeID, b.EmployeeID AS b_empid, a.OrderDate, b.Title";    // 要撈的資料表欄位。亦可寫成 * 或 a.* 全撈 (但建議只撈取 GridView 真正需要的欄位)
            //string strDefaultOrderColumn = "a.OrderID";                                 // 預設的排序欄位

            //string strSqlWhere = string.Empty;      // SELECT SQL 的 WHERE 條件 (包含使用者輸入的兩個搜尋關鍵字)

            //// 因 a,b 兩個資料表，都有 EmployeeID 欄位，若把 EmployeeID 欄位當作 JOIN 的 WHERE 條件式時，在 SQL Server 中會發生分不清是哪個欄位的錯誤，
            //// 因此再加入下列這段 if 判斷的處理
            //if (!string.IsNullOrEmpty(sortExpression))
            //{
            //    if ((sortExpression == "EmployeeID") || (sortExpression == "EmployeeID DESC"))
            //        sortExpression = "a." + sortExpression;

            //    if (sortExpression == "b_empid")
            //        sortExpression = "b.EmployeeID";
            //    else if (sortExpression == "b_empid DESC")
            //        sortExpression = "b.EmployeeID DESC";
            //}

            //// 若此 GridView 不提供使用者輸入關鍵字查詢功能，則免加以下這段
            //if (tbOrderID != "")        // 若使用者在前端畫面中，第一個關鍵字的 TextBox 有輸入，就進入此區塊
            //{
            //    strSqlWhere = strSqlWhere + "a.OrderID LIKE '%" + tbOrderID + "%' AND ";          // 關鍵字(字串)模糊查詢的寫法
            //}
            //if (tbCustomerID != "")      // 若使用者在前端畫面中，第二個關鍵字的 TextBox 有輸入，就進入此區塊
            //{
            //    strSqlWhere = strSqlWhere + "a.CustomerID LIKE '%" + tbCustomerID + "%' AND ";      // 關鍵字(字串)模糊查詢的寫法
            //}

            #endregion ****** 情況 3 - SELECT 多個資料表，使用 JOIN...ON 的寫法 (包括 LEFT JOIN 或 INNER JOIN) ******


            // 加上「ON (或 WHERE)」，再刪除最後一個過濾條件式，後面多出來的一組「AND」字樣
            if (strSqlWhere != string.Empty)
            {
                strSqlWhere = strSqlWhere.Remove(strSqlWhere.Length - 5, 5);
            }

            try
            {
                // 透過 DAL → DAL2 → 資料庫裡的 Stored Procedure，實際執行資料庫的「撈取」作業。
                // 參數: (Table名稱、查詢Column名稱集合、Where條件(包括模糊查詢關鍵字)、起始撈取的資料列索引、GridView每頁要顯示的筆數、排序欄位+排序方式)
                // 最後三個參數: (起始撈取的資料列索引、GridView每頁要顯示的筆數、排序欄位+排序方式)，ObjectDataSource 會自動從 .aspx 丟進來，不用開發人員傳遞
                ds = dba.selectDataSetBindGridView_DAL2(strTableName, strColumnName, strSqlWhere, strDefaultOrderColumn, startRowIndex, maxinumRows, sortExpression);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);        // DAL 層接到 RPTIDbAccess 元件傳來的錯誤訊息
            }

            return ds;

        } // end of selectDataSetBindGridView_DAL()


        // 從 Stored Procedure 回傳的一個整數，為符合查詢條件的資料總筆數，用來在 GridView 下方的「頁碼列」顯示頁碼之用(Ex: 1 2 3 4 ... 55)
        public int getRecordCountDAL()
        {
            return dba.sendRecordCountToDAL();
        }

        #endregion ****** 透過 RPTIDbAccess 的 SelectDataSet 函數，去 SELECT 資料庫並回傳一個 DataSet (搭配 Stored Procedure 做「分頁」處理) ******


    } // end of class
} // end of namespace